function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useRef, useState } from 'react';
import { Portal, Typography } from '../..';
export default {
  title: 'Atoms / Portal',
  parameters: {
    component: Portal
  }
};
export var DefaultStory = {
  render: function render() {
    return React.createElement(Portal, null, React.createElement(Typography, {
      type: "primary",
      as: "p"
    }, "This element is moved to the bottom of the body tag"));
  },
  name: 'Default'
};
export var PortalToSpecifiedDestination = {
  render: function render() {
    var ControlledExample = function ControlledExample() {
      var destination = useRef(null);
      var _useState = useState(false),
        _useState2 = _slicedToArray(_useState, 2),
        renderPortal = _useState2[0],
        setShouldRenderPortal = _useState2[1];
      useEffect(function () {
        if (destination && destination.current) {
          setShouldRenderPortal(true);
        }
      }, [destination]);
      return React.createElement(React.Fragment, null, React.createElement("div", {
        id: "destination",
        ref: destination
      }), renderPortal && React.createElement("div", {
        id: "origin"
      }, React.createElement(Portal, {
        attachTo: destination.current
      }, React.createElement(Typography, {
        type: "primary",
        as: "p"
      }, "This element is moved to a specified HTMLElement"))));
    };
    return React.createElement(ControlledExample, null);
  },
  name: 'Portal to specified destination'
};
export var IfAttachToPropIsNotAHtmlElementThenNothingIsRendered = {
  render: function render() {
    var ControlledExample = function ControlledExample() {
      var destination = useRef(null);
      return React.createElement("div", {
        id: "origin"
      }, React.createElement(Portal, {
        attachTo: destination.current
      }, React.createElement(Typography, {
        type: "primary",
        as: "p"
      }, "This element should not be rendered")));
    };
    return React.createElement(ControlledExample, null);
  },
  name: 'If attachTo prop is not a HTMLElement then nothing is rendered'
};